
import processing.serial.*;
import static javax.swing.JOptionPane.*;
 Serial myPort; 
 //teplotay a rssi jednotlivých modulů
 float temp1=0;
 float temp2=0;
 float temp3=0;
 
 int signal1=0;
 int signal2=0;
 int signal3=0;
 
 float maxTemp=-100f;
 float minTemp=100f;
 
  // proměnné obsahující počty přijatých a odeslaných paketů
 int sendPackets2;
 int receivedPackets2;
 int sendPackets3;
 int receivedPackets3;
 
 // proměnné obsahující čas od spuštění jednotlivých uzlů
 long millisOnLive1;
 long millisOnLive2;
 long millisOnLive3;
 
 // proměnné obsahující počet restartování jednotlivých uzlů
 int restarts2;
 int restarts3;
 char lastRestartedDevice='L';
 
 //Kolekce obsahující hodnoty do grafů
 ArrayList pointToRSSIGraph2 = new ArrayList();
 ArrayList pointToRSSIGraph3 = new ArrayList();
 ArrayList pointToTemperatureGraph1 = new ArrayList();
 ArrayList pointToTemperatureGraph2 = new ArrayList();
 ArrayList pointToTemperatureGraph3 = new ArrayList();
 int graphSize = 100;
 
 boolean dialogClosed=true;

void setup() {
  //inicializace Seriového portu
  try{
    String portName = Serial.list()[0];
    myPort = new Serial(this, portName, 9600);  
  }catch(ArrayIndexOutOfBoundsException e){
    println("Koordinátor nejspíše není připojen do PC");
    println(e);
    exit();
  }
  textSize(11);
  //velikost okna
  size(1000, 680);
  //obnovovací frekvence
  frameRate(15);
  background(255,255,255);
  delay(100);
   
 }
void draw() {
  if ( myPort.available() > 0) {
     updateData();
  }
  
  //smazání plochy
  background(255,255,255);
  setBackground();
  showDetails();
  showRSSIGraphs();
  showTempGraphs();
  drawRSSI();
  drawTemperature();
}

//nastavení statických prvků
void setBackground(){
strokeWeight(1);
  fill(0);
  text("Senzor 1",50,20);
  text("Koordinátor",50,40);
  text("Senzor 2",250,20);
  text("End device",250,40);
  text("Senzor 3",450,20);
  text("End device",450,40);
  
  fill(255);
  rect(130,20,100,20);
  rect(330,20,100,20);
  rect(530,20,100,20);
  
  strokeWeight(4);
  line(0,60,750,60);
  line(0,480,600,480);
  line(600,60,600,680);
  line(750,0,750,680);
  
  strokeWeight(1);
  for(int i=80;i<680;i+=80){
    fill(0);
    int tempValue=50-(i/8)+10;
    String txt=str(tempValue);
    if(tempValue==0){
      txt="0 °C";
    }    
    text(txt,4,i-4);
    line(0,i,600,i);
    for(int j=0;j<600;j+=2){
      point(j,i+40);
    }
  }
  fill(0);
}

//medota pro čtení dat ze seriové linky
 void updateData(){
   int val;
    val = myPort.read();
    if(val==0x7E){ //načtení startByte
      delay(50);//pozastavení aby se stihli data ze Seriové linky načist do bufferu
      char source=myPort.readChar();
      delay(50);
      int rssi=myPort.read();
      delay(50);
      int tempLenght=myPort.read();
      delay(50);
      String tString="";
      for(int i=0;i<tempLenght;i++){
        tString+=str(myPort.readChar());
      }
      if(source!='L'){
        if(source=='2'){
          delay(50);
          sendPackets2=getSendPacket();
          receivedPackets2=getReceivePacket();
        }
        else if(source=='3'){
          delay(50);
          sendPackets3=getSendPacket();
          receivedPackets3=getReceivePacket();
        }
      }
      long liveTime=0;
      delay(50);
      for(int i=0;i<8;i++){
         liveTime+=myPort.read();
         if(i<7){
           liveTime*=0x100;
         }
      }
      if(source=='L'){
        int restartFailed = myPort.read();
        lastRestartedDevice = myPort.readChar();
        if(restartFailed==0x01){
          if(dialogClosed){
            thread("popupWindow");
          }
        }
      }else{
        if(source=='2'){
          restarts2=myPort.read();
        }
        else if(source=='3'){
          restarts3=myPort.read();
        }
      }
      try{
        float temp=Float.parseFloat(tString);
        checkAndSetData(temp,source,rssi,liveTime);
      }catch(NumberFormatException e){
        println(e);
        delay(500);
      } //<>//
    }  
 }
 //metoda pro přečtení odeslaných paketů
 int getSendPacket(){
         int sendPackets=0;
          for(int i=0;i<4;i++){
            sendPackets+=myPort.read();
            if(i<3){
              sendPackets*=0x100;
            }
          }
          return sendPackets;
 }
  //metoda pro přečtení přijatých paketů
  int getReceivePacket(){      
        int receivedPackets=0;
          for(int i=0;i<4;i++){
            receivedPackets+=myPort.read();
            if(i<3){
              receivedPackets*=0x100;
            }
          }
          return receivedPackets+1;
 }
 //vykreslení síly signálu
 void drawRSSI(){ 
  if(signal2==666){
     fill(255,255,0);
     triangle(355, 45, 380, 5, 405, 45);
     fill(0);
     textSize(32);
     text('!',375,40);  
     textSize(11);
  }else{
    fill(0);
    text(signal2+"%",330+40,15);
    fill(0,255,0);
    rect(330,20,signal2,20);
  }
  if(signal3==666){
     fill(255,255,0);
     triangle(555, 45, 580, 5, 605, 45);
     fill(0);
     textSize(32);
     text('!',575,40);  
     textSize(11);
  }else{
    fill(0);
    text(signal3+"%",530+40,15);
    fill(0,255,0);
    rect(530,20,signal3,20);
  }
    fill(0);
    text(signal1+"%",130+40,15);
    fill(0,255,0);
    rect(130,20,signal1,20);
 }
 
 void drawTemperature(){
  //hodnoty pro velikost obdelniku zobrazujici teplotu
  //1°C je 8px
  float t1=temp1*8;
  float t2=temp2*8;
  float t3=temp3*8;
  
  float text1;
  float text2;
  float text3;
  //vykreslení teploty
  strokeWeight(0);
  if(temp1>0){
    text1=480-t1+12;
    fill(255,70,70);
  }else{
    text1=480-t1-5;
    fill(0,206,209);
  }
  rect(50.0,480.0,100.0,-t1);
  fill(0);
  text(temp1+" °C",75,text1);
  
  if(temp2>0){  
    text2=480-t2+12;
    fill(255,70,70);
  }else{
    text2=480-t2-5;
    fill(0,206,209);
  }
  rect(250.0,480.0,100,-t2);
  fill(0);
  text(temp2+" °C",275,text2);
  
  if(temp3>0){ 
    text3=480-t3+12;
    fill(255,70,70);
  }else{
    text3=480-t3-5;
    fill(0,206,209);
  }
  rect(450.0,480.0,100,-t3);
  fill(0);
   text(temp3+" °C",475,text3);
 }
 // metoda pro zobrazení informací ve stavovém sloupci
 void showDetails(){
   text("Senzor 1:",650,80);
   text("Doba od spuštění", 610,100);
   int[] live1=splitShowTime(millisOnLive1);
   text(live1[0]+" h "+live1[1]+" m "+live1[2]+","+live1[3]+" s",610,120);
   line(600,130,750,130);
   text("Senzor 2:",650,145);
   text("Doba od spuštění", 610,165);
   int[] live2=splitShowTime(millisOnLive2);
   text(live2[0]+" h "+live2[1]+" m "+live2[2]+","+live2[3]+" s",610,185);
   text("Počet odeslaných paketů",610,205);
   text(sendPackets2,610,225);
   text("Počet přijatých paketů",610,245);
   text(receivedPackets2,610,265);
   text("Ztracené pakety",610,285);
   showLostPackets(sendPackets2, receivedPackets2,610,305);
   text("Restartováno",610,325);
   text(restarts2+"x",610,345);
   line(600,355,750,355);
   text("Senzor 3:",650,370);
   text("Doba od spuštění", 610,390);
   int[] live3=splitShowTime(millisOnLive3);
   text(live3[0]+" h "+live3[1]+" m "+live3[2]+","+live3[3]+" s",610,410);
   text("Počet odeslaných paketů",610,430);
   text(sendPackets3,610,450);
   text("Počet přijatých paketů",610,470);
   text(receivedPackets3,610,490);
   text("Ztracené pakety",610,510);
   showLostPackets(sendPackets3, receivedPackets3,610,530);
   text("Restartováno",610,550);
   text(restarts3+"x",610,570);
   line(600,580,750,580);
   text("Maximální teplota",610,595);
   text(maxTemp+" °C",610,615);
   text("Minimální teplota",610,635);
   text(minTemp+" °C",610,655);
 }
 //metoda pro výpočet a zobrazení ztracených paketů
 void showLostPackets(int send, int received,int x,int y){
   if(send!=0){
     float rate = (float)received/send;
     rate = rate*100f; 
     rate = 100f-rate;
     int lost = send-received;
     text(lost+" | "+rate+"%",x,y);
   }
 }
 // zkontroluje a nastaví data do proměnných
 void checkAndSetData(float teplota, char zdroj, int rssi,long liveTime){
   if(maxTemp<teplota){
         maxTemp=teplota;
       } 
       if(minTemp>teplota){
         minTemp=teplota;
       }
      if(zdroj=='L'){
        signal1=rssi;
        temp1=teplota;
        pointToTemperatureGraph1.add((Float)temp1);
        millisOnLive1=liveTime;
      }else if(zdroj=='2'){
        signal2=rssi;
        pointToRSSIGraph2.add((Integer)signal2);
        temp2=teplota;
        pointToTemperatureGraph2.add((Float)temp2);
        millisOnLive2=liveTime;
      }else if(zdroj=='3'){
        signal3=rssi;
        pointToRSSIGraph3.add((Integer)signal3);
        temp3=teplota-35;
        pointToTemperatureGraph3.add((Float)temp3);
        millisOnLive3=liveTime;
      }
 }
 //rozdělí čas v milisekundách na HH:MM:SS.sss
 int[] splitShowTime(long timeToSplit){
   int miliseconds = (int)timeToSplit%1000;
   timeToSplit=timeToSplit/1000;
   int hours=(int)timeToSplit/3600;
   timeToSplit=timeToSplit%3600;
   int minutes=(int)timeToSplit/60;
   int seconds=(int)timeToSplit%60;
   return new int[]{hours, minutes, seconds, miliseconds};
 }
 //metoda pro vykreslení kolekce RSSI grafů
 void showRSSIGraphs(){
   showRSSIGraph(pointToRSSIGraph2,790,129,200,101,"2");
   showRSSIGraph(pointToRSSIGraph3,790,359,200,101,"3");
 }
 //metoda pro vykreslení RSSI grafu
 void showRSSIGraph(ArrayList pointToRSSIGraph, int x1, int y1, int x2, int y2, String nodeNumber){
   stroke(160,160,160);
   for(int i=10;i<y2-1;i+=10){
     line(x1,y1+i+1,x1+x2,y1+i+1);
    }
    for(int i =20;i<x2;i+=20){
      line(x1+i,y1+1,x1+i,y1+y2);
    }
    stroke(0);
    for(int i=0;i<=100;i+=20){
       text(100-i+" %",x1-35,y1+5+i);
    }
   fill(0,0,0,0);
   rect(x1,y1,x2,y2);
   fill(0);
   text("Senzor "+nodeNumber+" - RSSI - "+graphSize+" paketů", x1+20,y1-4);
   fill(255);
   if(pointToRSSIGraph.size()>graphSize){
     pointToRSSIGraph.remove(0);
   }
   int prevX=0, prevY=0;
   for(int i=0;i<pointToRSSIGraph.size();i++){
     stroke(0,255,0,127);  
     if(prevX == 0 && prevY ==0){
         prevX=i;prevY=((int)pointToRSSIGraph.get(i));
       }else{
        line(x1+(i*2), y1+y2-(prevY+(((int)pointToRSSIGraph.get(i))-prevY)/2), x1+(i*2), y1+y2);
       }
       line(x1+1+(i*2), y1+y2-((int)pointToRSSIGraph.get(i)), x1+1+(i*2), y1+y2);
      stroke(0);
      line(x1+1+(prevX*2), y1+y2-prevY, x1+1+(i*2), y1+y2-((int)pointToRSSIGraph.get(i)));
      prevX=i;prevY=((int)pointToRSSIGraph.get(i));
   }
   fill(0);
  
 }
 //metoda pro vykreslení kolekce teplotních grafů
 void showTempGraphs(){
   showTempGraph(pointToTemperatureGraph1,790,29,200,71,"1");
   showTempGraph(pointToTemperatureGraph2,790,259,200,71,"2");
   showTempGraph(pointToTemperatureGraph3,790,489,200,71,"3");
 } 
 //metoda pro vykreslení teplotního grafu
 void showTempGraph(ArrayList pointToGraph,int x1,int y1,int x2, int y2, String nodeNumber){
   fill(0,0,0,0);
   rect(x1,y1,x2,y2);
   fill(0);
   text("Senzor "+nodeNumber+" - Teplota - "+graphSize+" paketů", x1+20,y1-4);
  
   if(pointToGraph.size()>graphSize){
     pointToGraph.remove(0);
   }
   int max=-20; 
   int min=50;
   for(int i=0;i<pointToGraph.size();i++){
     if(max<(float)pointToGraph.get(i)){
       max=int((float)(pointToGraph.get(i)));
     }
     if(min>(float)pointToGraph.get(i)){
       min=int((float)(pointToGraph.get(i)));
     }
   }
   int graphSample=5;
   int limitL;
   int limitH;
   int heightOfGraph=y2-1;
   if(min<0){
     limitL=(min/graphSample)-1;   
   }else{
     limitL=min/graphSample;
   }
   limitL*=graphSample;
   if(max<0){
     limitH=max/graphSample;
   } else{
     limitH=(max/graphSample)+1;
   }
   limitH*=graphSample;
   if(limitH>50){
     limitH=50;
   }
   if(limitL<-20){
     limitL=-20;
   }
   
   if(pointToGraph.size()>0){
     text(limitL+"°C",x1-35,y1+y2+5);
     text(limitH+"°C",x1-35,y1+6);
   }
   int limitDiv=limitH-limitL;
   int numberOfLines=limitDiv/5;
   float gapSize=float(heightOfGraph)/numberOfLines;
   stroke(160,160,160);
   for(int i=1;i<numberOfLines;i++){
     line(x1+1,y1+y2-(gapSize*i),x1+x2-1,y1+y2-(gapSize*i));
   }
   for(int i =20;i<200;i+=20){
    line(x1+i+1,y1+1,x1+1+i,y1+y2-1);
  }
   float pixelsToDegree=float(heightOfGraph)/limitDiv;
   fill(255);
   float prevX=0, prevY=0;
   for(int i=0;i<pointToGraph.size();i++){
     if((float)pointToGraph.get(i)<0){
       stroke(0,206,209,127);
     }else{
       stroke(255,0,0,127);
     }  
     float pixelsFromLimitL=((float)pointToGraph.get(i)-limitL)*pixelsToDegree;
     if(pixelsFromLimitL>heightOfGraph){
       pixelsFromLimitL=heightOfGraph;
     }else if(pixelsFromLimitL<0)
     {pixelsFromLimitL=0;}
     if(prevX == 0 && prevY ==0){
         
         prevX=i;prevY=pixelsFromLimitL;
       }else{
        line(x1+1+(i*2)-1, y1+y2-(prevY+((pixelsFromLimitL)-prevY)/2), x1+1+(i*2)-1, y1+y2); //<>//
       }
       line(x1+1+(i*2), y1+y2-(pixelsFromLimitL), x1+1+(i*2), y1+y2);
       stroke(0);
      line(x1+1+(prevX*2), y1+y2-prevY, x1+1+(i*2), y1+y2-pixelsFromLimitL);
       prevX=i;prevY=pixelsFromLimitL;
   }
   stroke(0);
   fill(0);
 }
 //metoda pro zobrazení dialogového okna
 void popupWindow(){
   dialogClosed=false;
   setWarningNotification(lastRestartedDevice);
   showMessageDialog(null, "Restart End Node č. "+lastRestartedDevice+" SELHAL - zkontrolujte zda je zapnutý", 
    "Varování", WARNING_MESSAGE);
   dialogClosed=true;
 }
 //metoda nastavující indikátor selhání
 void setWarningNotification(char device){
   switch(device){
     case '2':
        signal2=666;
        break;
     case '3':
        signal3=666;
        break;
     default:
       break;
   }
 }